misc fixes and improvements
[distro-setup] / brc
1 #!/bin/bash
2 # Copyright (C) 2019 Ian Kelling
3 # SPDX-License-Identifier: AGPL-3.0-or-later
4 # this gets sourced. shebang is just for file mode detection
5
6 # Use source ~/.bashrc instead of doing bash -l when running a script
7 # so this can set extdebug and avoid the bash debugger.
8 if [[ -s /a/bin/errhandle/err ]]; then
9 source /a/bin/errhandle/err
10 elif [[ -s $bashrc_dir/err ]]; then
11 # shellcheck source=/a/bin/errhandle/err
12 source $bashrc_dir/err
13 fi
14
15 # In t8, it runs clear_console for login shells by default. I don't want
16 # my console cleared. And linux ttys get cleared without this.
17 if shopt login_shell >/dev/null && [[ -e ~/.bash_logout ]]; then
18 rm ~/.bash_logout
19 fi
20
21 # if [[ -s /usr/share/bash-completion/completions/git ]]; then
22 # source /usr/share/bash-completion/completions/git
23 # fi
24 # if [[ -s /usr/share/bash-completion/completions/gitk ]]; then
25 # source /usr/share/bash-completion/completions/gitk
26 # fi
27
28 # for testing error catching:
29 # t2() {
30 # echo t2
31 # grep sdf sdfd
32 # echo wtf
33 # }
34 # t1() {
35 # echo t1
36 # t2 a b c
37 # }
38
39 # * settings
40
41 CDPATH=.
42
43
44 # remove all aliases. aliases provided by the system tend to get in the way,
45 # for example, error happens if I try to define a function the same name as an alias
46 unalias -a
47
48 # remove gnome keyring warning messages
49 # there is probably a more proper way, but I didnt find any easily on google
50 # now using xfce+xmonad instead of vanilla xmonad, so disabling this
51 #unset GNOME_KEYRING_CONTROL
52
53 # use extra globing features.
54 shopt -s extglob
55 # include .files when globbing, but ignore files name . and ..
56 # setting this also sets dotglob.
57 export GLOBIGNORE="*/.:*/.."
58
59 # Useful info. see man bash.
60 PS4='$LINENO+ '
61
62
63 # broken with bash_completion package. Saw a bug for this once. dont anymore.
64 # still broken in wheezy
65 # still buggered in latest stable from the web, version 2.1
66 # perhaps its fixed in newer git version, which fails to make for me
67 # this note is from 6-2014.
68 # still broken in flidas.
69 #shopt -s nullglob
70
71 # make tab on an empty line do nothing
72 shopt -s no_empty_cmd_completion
73
74 # fix spelling errors for cd, only in interactive shell
75 shopt -s cdspell
76 # append history instead of overwritting it
77 shopt -s histappend
78 # for compatibility, per gentoo/debian bashrc
79 shopt -s checkwinsize
80 # attempt to save multiline single commands as single history entries.
81 shopt -s cmdhist
82 # enable **
83 shopt -s globstar
84
85
86 # inside emacs fixes
87 if [[ $LC_INSIDE_EMACS ]]; then
88 # EMACS is used by bash on startup, but we dont need it anymore.
89 # plus I hit a bug in a makefile which inherited it
90 unset EMACS
91 export LC_INSIDE_EMACS
92 export PAGER=cat
93 export MANPAGER=cat
94 # scp completion does not work, but this doesnt fix it. todo, figure this out
95 #complete -r scp &> /dev/null
96 # todo, remote file completion fails, figure out how to turn it off
97 export NODE_DISABLE_COLORS=1
98 # This gets rid of ugly terminal escape chars in node repl
99 # sometime, Id like to have completion working in emacs shell for node
100 # the offending chars can be found in lib/readline.js,
101 # things that do like:
102 # stream.write('\x1b[' + (x + 1) + 'G');
103 # We can remove them and keep readline, for example by doing this
104 # to start a repl:
105 #!/usr/bin/env nodejs
106 # var readline = require('readline');
107 # readline.cursorTo = function(a,b,c) {};
108 # readline.clearScreenDown = function(a) {};
109 # const repl = require('repl');
110 # var replServer = repl.start('');
111 #
112 # no prompt, or else readline complete seems to be confused, based
113 # on our column being different? node probably needs to send
114 # different kind of escape sequence that is not ugly. Anyways,
115 # completion doesnt work yet even with the ugly prompt, so whatever
116 #
117 export NODE_NO_READLINE=1
118
119 fi
120
121 export SSH_CONFIG_FILE_OVERRIDE=/root/.ssh/confighome
122
123 # emacs has a different default search path than the info command. This
124 # adds the info defaults to emacs, but not the reverse, because I dun
125 # care much about the cli. The search path is only on the cli if you run
126 # "info xxx", or in emacs if you run '(info xxx)', so not that
127 # important, but might as well fix it.
128
129 # info info says this path is what was compiled, and its not documented
130 # anywhere. Through source grepping, i found it in filesys.h of the info
131 # source in trisquel flidas.
132 #
133 # Traling : means for emacs to add its own stuff on to the end.
134
135 export INFOPATH=$PATH:/usr/local/info:/usr/info:/usr/local/lib/info:/usr/lib/info:/usr/local/gnu/info:/usr/local/gnu/lib/info:/usr/gnu/info:/usr/gnu/lib/info:/opt/gnu/info:/usr/share/info:/usr/share/lib/info:/usr/local/share/info:/usr/local/share/lib/info:/usr/gnu/lib/emacs/info:/usr/local/gnu/lib/emacs/info:/usr/local/lib/emacs/info:/usr/local/emacs/info:.:
136
137 # for openwrt system that has no stty, this is easier than
138 # guarding every time i use it.
139 if ! type -p stty >/dev/null; then
140 stty() { :; }
141 fi
142
143
144 if [[ $- == *i* ]]; then
145 # for readline-complete.el
146 if [[ $LC_INSIDE_EMACS ]]; then
147 # all for readline-complete.el
148 stty echo
149 bind 'set horizontal-scroll-mode on'
150 bind 'set print-completions-horizontally on'
151 bind '"\C-i": self-insert'
152 else
153
154 if [[ $KONSOLE_PROFILE_NAME ]]; then
155 TERM=xterm-256color
156 fi
157
158 if [[ $TERM == alacritty && ! -e /usr/share/terminfo/a/alacritty ]]; then
159 # todo: we should try installing the alacritty terminfo if it is not found
160 # https://github.com/alacritty/alacritty/issues/2838
161 TERM=xterm-256color
162 fi
163
164 # copying from the alacritty example above,
165 if [[ $TERM == xterm-kitty ]]; then
166 if [[ ! -e /usr/share/terminfo/x/xterm-kitty ]]; then
167 TERM=xterm-256color
168 else
169 if [[ -e /a/opt/kitty/shell-integration/bash/kitty.bash ]]; then
170 KITTY_SHELL_INTEGRATION=t
171 source /a/opt/kitty/shell-integration/bash/kitty.bash
172 fi
173 fi
174 fi
175
176 # todo: not sure this works in sakura
177 #stty werase undef
178 #bind "\C-w": kill-region
179 # sakura == xterm-256color
180 # konsole == xterm
181 if [[ $TERM != xterm-kitty && $TERM == xterm* ]]; then
182 # control + arrow keys. for other terminals, see http://unix.stackexchange.com/questions/10806/how-to-change-previous-next-word-shortcut-in-bash
183 bind '"\e[1;5C": shell-forward-word' 2>/dev/null
184 bind '"\e[1;5D": shell-backward-word' 2>/dev/null
185 else
186 # make ctrl-backspace work. for konsole, i fixed it through
187 # /home/iank/.local/share/konsole/default.keytab
188 stty werase ^h
189 bind '"\eOc": shell-forward-word'
190 bind '"\eOd": shell-backward-word'
191 fi
192 # i cant remember why i did this, probably to free up some keys to bind
193 # to other things in bash.
194 # other than C-c and C-z, the rest defined by stty -a are, at least in
195 # gnome-terminal, overridden by bash, or disabled by the system
196 stty lnext undef stop undef start undef
197 fi
198
199 fi
200
201 export BC_LINE_LENGTH=0
202
203 # ansible option
204 export PROFILE_TASKS_TASK_OUTPUT_LIMIT=100
205
206 # note, if I use a machine I dont want files readable by all users, set
207 # umask 077 # If fewer than 4 digits are entered, leading zeros are assumed
208
209 # i for insensitive. the rest from
210 # X means dont remove the current screenworth of output upon exit
211 # R means to show colors n things
212 export LESS=RXij12
213 export SYSTEMD_LESS=$LESS
214
215 export NNN_COLORS=2136
216
217 export SL_FILES_DIR=/b/ds/sl/.iank
218 export SL_INFO_DIR=/p/sshinfo
219
220
221 # * include files
222
223 if [[ -s $bashrc_dir/path-add-function ]]; then
224 source $bashrc_dir/path-add-function
225 if [[ $SSH_CLIENT ]]; then
226 # [[ -d /home/iank/.iank/e/e ]] mounts it unnecessarily, so use this.
227 if grep -qF /home/iank/.iank/e/e /etc/auto.iank /etc/exports &>/dev/null; then
228 export EMACSDIR=/home/iank/.iank/e/e
229 fi
230 path-add $bashrc_dir
231 fi
232 fi
233
234 # if someone exported $SOE (stop on error), catch errors.
235 #
236 # Note, on debian this results in the following warning when in ssh,
237 # hich I haven't figured out how to fix. It doesn't happen if we source
238 # after the shell has started
239 #
240 # bash: /usr/share/bashdb/bashdb-main.inc: No such file or directory
241 # bash: warning: cannot start debugger; debugging mode disabled
242 if [[ $SOE ]]; then
243 if [[ -e /a/bin/errhandle/err ]]; then
244 source /a/bin/errhandle/err
245 fi
246 fi
247
248 # based on readme.debian. dunno if this will break on other distros.
249 if [[ -s /usr/share/wcd/wcd-include.sh ]]; then
250 source /usr/share/wcd/wcd-include.sh
251 fi
252
253
254 mysrc() {
255 local path dir file
256 path=$1
257 dir=${path%/*}
258 file=${path##*/}
259 if [[ -s $path ]]; then
260 source $path
261 elif [[ -s $bashrc_dir/$file ]]; then
262 source $bashrc_dir/$file
263 fi
264 }
265
266
267 mysrc /a/bin/small-misc-bash/ll-function
268 mysrc /a/bin/distro-functions/src/package-manager-abstractions
269
270
271 # * functions
272 ccomp() { # copy completion
273 local src=$1
274 local c
275 shift
276 if ! c=$(complete -p $src 2>/dev/null); then
277 _completion_loader $src &>/dev/null ||:
278 c=$(complete -p $src 2>/dev/null) || return 0
279 fi
280 # remove $src( .*|$)
281 c=${c% $src}
282 c=${c%% $src *}
283 eval $c $*
284 }
285
286
287 ..() { c ..; }
288 ...() { c ../..; }
289 ....() { c ../../..; }
290 .....() { c ../../../..; }
291 ......() { c ../../../../..; }
292
293 chere() {
294 local f path
295 for f; do
296 path=$(readlink -e "$f")
297 echo "cat >$path <<'EOF'"
298 cat "$f"
299 echo EOF
300 done
301 }
302
303
304 # file cut copy and paste, like the text buffers :)
305 # I havnt tested these.
306 _fbufferinit() { # internal use
307 ! [[ $my_f_tempdir ]] && my_f_tempdir=$(mktemp -d)
308 rm -rf "${my_f_tempdir:?}"/*
309 }
310 fcp() { # file cp
311 _fbufferinit
312 cp "$@" "$my_f_tempdir"/
313 }
314 fct() { # file cut
315 _fbufferinit
316 mv "$@" "$my_f_tempdir"/
317 }
318 fpst() { # file paste
319 [[ $2 ]] && { echo too many arguments; return 1; }
320 target=${1:-.}
321 cp "$my_f_tempdir"/* "$target"
322 }
323
324 _khfix_common() {
325 local host ip port
326 read -r host ip port < <(timeout -s 9 2 ssh -oBatchMode=yes -oControlMaster=no -oControlPath=/ -v $1 |& sed -rn "s/debug1: Connecting to ([^ ]+) \[([^\]*)] port ([0-9]+).*/\1 \2 \3/p" ||: )
327 if [[ ! $ip ]]; then
328 echo "khfix: ssh failed"
329 return 1
330 fi
331 if [[ $port != 22 ]]; then
332 ip_entry="[$ip]:$port"
333 host_entry="[$host]:$port"
334 else
335 ip_entry=$ip
336 host_entry=$host
337 fi
338 if [[ $host != $ip ]]; then
339 m ssh-keygen -R "$host_entry" -f $(readlink -f ~/.ssh/known_hosts)
340 ll ~/.ssh/known_hosts
341 fi
342 m ssh-keygen -R "$ip_entry" -f $(readlink -f ~/.ssh/known_hosts)
343 ll ~/.ssh/known_hosts
344 rootsshsync
345 }
346 khfix() { # known hosts fix
347 _khfix_common "$@" || return 1
348 ssh $1 :
349 }
350 khcopy() {
351 _khfix_common "$@"
352 ssh-copy-id $1
353 }
354
355 a() {
356 local x
357 x=$(readlink -nf "${1:-$PWD}")
358 # yes, its kinda dumb that xclip/xsel cant do this in one invocation
359 echo -n "$x" | xclip -selection clipboard
360 echo -n "$x" | xclip
361 }
362
363 # a1 = awk {print $1}
364 for field in {1..20}; do
365 eval a$field"() { awk '{print \$$field}'; }"
366 done
367 # h1 = head -n1
368 for num in {1..9}; do
369 eval h$num"() { head -n$num; }"
370 done
371
372
373 b() {
374 # backwards
375 c -
376 }
377
378
379 # c. better cd
380 if type -p wcd &>/dev/null; then
381 if [[ $LC_INSIDE_EMACS ]]; then
382 c() { wcd -c -z 50 -o "$@"; }
383 else
384 # lets see what the fancy terminal does from time to time
385 c() { wcd -c -z 50 "$@"; }
386 fi
387 else
388 c() { cd "$@"; }
389 fi
390 ccomp cd c
391
392 c4() { c /var/log/exim4; }
393
394 caa() { git commit --amend --no-edit -a; }
395
396 cf() {
397 for f; do
398 hr
399 echo "$f"
400 hr
401 cat "$f"
402 done
403 }
404 caf() {
405 # shellcheck disable=SC2033
406 find -L "$@" -type f -not \( -name .svn -prune -o -name .git -prune \
407 -o -name .hg -prune -o -name .editor-backups -prune \
408 -o -name .undo-tree-history -prune \) \
409 -exec bash -c '. ~/.bashrc; hr; echo "$1"; hr; cat "$1"' _ {} \; 2>/dev/null
410
411 }
412 ccomp cat cf caf
413
414 calc() { echo "scale=3; $*" | bc -l; }
415 # no having to type quotes, but also no command history:
416 clc() {
417 local x
418 read -r x
419 echo "scale=3; $x" | bc -l
420 }
421
422 cam() {
423 git commit -am "$*"
424 }
425
426 ccat () { # config cat. see a config without extra lines.
427 sed -r '/^[[:space:]]*([;#]|--|\/\/|$)/d' "$@"
428 }
429 ccomp grep ccat
430
431 chrbind() {
432 local d
433 # dev/pts needed for pacman signature check
434 for d in dev proc sys dev/pts; do
435 [[ -d $d ]]
436 if ! mountpoint $d &>/dev/null; then
437 s mount -o bind /$d $d
438 fi
439 done
440 }
441
442
443 _cdiff-prep() {
444 # join options which are continued to multiples lines onto one line
445 local first=true
446 while IFS= read -r line; do
447 # remove leading spaces/tabs. assumes extglob
448 if [[ $line == "[ ]*" ]]; then
449 line="${line##+( )}"
450 fi
451 if $first; then
452 pastline="$line"
453 first=false
454 elif [[ $line == *=* ]]; then
455 echo "$pastline" >> "$2"
456 pastline="$line"
457 else
458 pastline="$pastline $line"
459 fi
460 done < <(grep -vE '^([ \t]*#|^[ \t]*$)' "$1")
461 echo "$pastline" >> "$2"
462 }
463
464 cdiff() {
465 # diff config files,
466 # setup for format of postfix, eg:
467 # option = stuff[,]
468 # [more stuff]
469 local pastline unified f1 f2
470 unified="$(mktemp)"
471 f1="$(mktemp)"
472 f2="$(mktemp)"
473 _cdiff-prep "$1" "$f1"
474 _cdiff-prep "$2" "$f2"
475 cat "$f1" "$f2" | grep -Po '^[^=]+=' | sort | uniq > "$unified"
476 while IFS= read -r line; do
477 # the default bright red / blue doesnt work in emacs shell
478 dwdiff -cblue,red -A best -d " ," <(grep "^$line" "$f1" || echo ) <(grep "^$line" "$f2" || echo ) | colordiff
479 done < "$unified"
480 }
481
482
483 cat-new-files() {
484 local start=$SECONDS
485 local dir="$1"
486 inotifywait -m "$dir" -e create -e moved_to |
487 # shellcheck disable=SC2030
488 while read -r filedir _ file; do
489 cat "$filedir$file"
490 hr
491 calc $((SECONDS - start)) / 60
492 sleep 5
493 done
494
495 }
496
497 # shellcheck disable=SC2032
498 chown() {
499 # makes it so chown -R symlink affects the symlink and its target.
500 if [[ $1 == -R ]]; then
501 shift
502 command chown -h "$@"
503 command chown -R "$@"
504 else
505 command chown "$@"
506 fi
507 }
508
509 cim() {
510 git commit -m "$*"
511 }
512
513 cl() {
514 # choose recent directory. cl = cd list
515 c =
516 }
517
518 d() { builtin bg "$@"; }
519 ccomp bg d
520
521 dc() {
522 diff --strip-trailing-cr -w "$@" # diff content
523 }
524 ccomp diff dc
525
526 despace() {
527 local x y
528 for x in "$@"; do
529 y="${x// /_}"
530 safe_rename "$x" "$y"
531 done
532 }
533
534 dig() {
535 command dig +nostats +nocmd "$@"
536 }
537 # Output with sections sorted, and removal of query id, so 2 dig outputs can be diffed.
538 digsort() {
539 local sec
540 sec=
541 dig +nordflag "$@" | sed -r 's/^(;; ->>HEADER<<-.*), id: .*/\1/' | while read -r l; do
542 if [[ $l == [^\;]* ]]; then
543 sec+="$l"$'\n'
544 else
545 if [[ $sec ]]; then
546 printf "%s" "$sec" | sort
547 sec=
548 fi
549 printf "%s\n" "$l"
550 fi
551 done
552 }
553 ccomp dig digsort
554 # compare digs to the 2 servers
555 # usage: digdiff @server1 @server2 DIG_ARGS
556 # note: only the soa master nameserver will respond with
557 # ra "recursive answer" flag. That difference is meaningless afaik.
558 digdiff() {
559 local s1 s2
560 s1=$1
561 shift
562 s2=$1
563 shift
564 digsort $s1 "$@" | tee /tmp/digdiff
565 diff -u /tmp/digdiff <(digsort $s2 "$@")
566 }
567
568 dt() {
569 date "+%A, %B %d, %r" "$@"
570 }
571 ccomp date dt
572
573 dus() { # du, sorted, default arg of
574 du -sh ${@:-*} | sort -h
575 }
576 ccomp du dus
577
578
579 e() { echo "$@"; }
580
581 # echo args
582 ea() {
583 if (( ! $# )); then
584 echo no args
585 fi
586 for arg; do
587 printf "%qEOL\n" "${arg}"
588 printf "%s" "${arg}" |& hexdump -C
589 done
590 }
591 # echo vars. print var including escapes, etc
592 ev() {
593 if (( ! $# )); then
594 echo no args
595 fi
596 for arg; do
597 printf "%qEOL\n" "${!arg}"
598 printf "%s" "${!arg}" |& hexdump -C
599 done
600 }
601
602 ediff() {
603 [[ ${#@} == 2 ]] || { echo "error: ediff requires 2 arguments"; return 1; }
604 emacs --eval "(ediff-files \"$1\" \"$2\")"
605 }
606
607 # mail related
608 etail() {
609 tail -F /var/log/exim4/mainlog -n 200 "$@"
610 }
611 ccomp tail etail
612
613 # print exim old pids
614 eoldpids() {
615 local configtime pid piduptime now daemonpid
616 printf -v now '%(%s)T' -1
617 configtime=$(stat -c%Y /var/lib/exim4/config.autogenerated)
618 if [[ -s /run/exim4/exim.pid ]]; then
619 daemonpid=$(cat /run/exim4/exim.pid)
620 fi
621 for pid in $(pgrep -f '^/usr/sbin/exim4( |$)'); do
622 # the daemonpid gets reexeced on HUP (service reloads), keeping its same old timestamp
623 if [[ $pid == $daemonpid ]]; then
624 continue
625 fi
626 piduptime=$(awk -v ticks="$(getconf CLK_TCK)" 'NR==1 { now=$1; next } END { printf "%9.0f\n", now - ($20/ticks) }' /proc/uptime RS=')' /proc/$pid/stat) ||: # sometimes pids disappear pretty fast
627 if (( configtime > now - piduptime )); then
628 echo $pid
629 fi
630 done
631 }
632
633 # exim tail but only watch lines from new pids
634 etailnew() {
635 local pid oldpids
636 for pid in $(eoldpids); do
637 oldpids+="$pid|"
638 done
639 if [[ $oldpids ]]; then
640 etail | awk '$3 !~ /^\[('"${oldpids%|}"')\]$/'
641 else
642 etail
643 fi
644 }
645 # exim watch as old pids go away
646 ewatchold() {
647 local configtime pid piduptime now
648 local -i count
649 local -a oldpids
650 count=0
651 while true; do
652 oldpids=($(eoldpids))
653 if (( ! ${#oldpids[@]} )); then
654 return
655 fi
656 # print the date every 20 iterations
657 if (( ! count % 20 )); then
658 date
659 fi
660 count+=1
661 ps -f -p "${oldpids[*]}"
662 sleep 1
663 done
664 }
665
666 eless() {
667 less /var/log/exim4/mainlog
668 }
669 ccomp less eless
670 eqcat() {
671 exiqgrep -i -o 60 | while read -r i; do
672 hlm exim -Mvc $i
673 echo
674 hlm exigrep $i /var/log/exim4/mainlog | cat ||:
675 done
676 }
677 eqrmf() {
678 exiqgrep -i | xargs exim -Mrm
679 }
680
681 econfdevnew() {
682 rm -rf /tmp/edev
683 mkdir -p /tmp/edev/etc
684 cp -ra /etc/exim4 /tmp/edev/etc
685 cp -ra /etc/alias* /tmp/edev/etc
686 find /tmp/edev/etc/exim4 -type f -execdir sed -i "s,/etc/,/tmp/edev/etc/,g" '{}' +
687 econfdev
688 }
689 econfdev() {
690 update-exim4.conf -d /tmp/edev/etc/exim4 -o /tmp/edev/e.conf
691 }
692
693
694
695 # shellcheck disable=SC2032
696 f() {
697 # cd forward
698 c +
699 }
700
701 fa() {
702 # find array. make an array of file names found by find into $x
703 # argument: find arguments
704 # return: find results in an array $x
705 while read -rd ''; do
706 x+=("$REPLY");
707 done < <(find "$@" -print0);
708 }
709
710 faf() { # find all files. use -L to follow symlinks
711 find "$@" -not \( -name .svn -prune -o -name .git -prune \
712 -o -name .hg -prune -o -name .editor-backups -prune \
713 -o -name .undo-tree-history -prune \) -type f 2>/dev/null
714 }
715
716 # todo: id like to do maybe a daily or hourly cronjob to
717 # check that my history file size is increasing. Ive had it
718 # inexplicably truncated in the past.
719 histrm() {
720 history -n
721 history | awk -v IGNORECASE=1 '{ a=$1; sub(/^( *[^ ]+){4} */, "") }; /'"$*"'/'
722 read -p "press anything but contrl-c to delete"
723 for entry in $(history | awk -v IGNORECASE=1 '{ a=$1; sub(/^( *[^ ]+){4} */, "") }; /'"$*"'/ { print a }' | tac); do
724 history -d $entry
725 done
726 history -w
727 }
728
729 # mail related
730 frozen() {
731 rm -rf /tmp/frozen
732 sudo mailq |gr frozen|awk '{print $3}' | while read -r id; do
733 sudo exim -Mvl $id
734 echo
735 sudo exim -Mvh $id
736 echo
737 sudo exim -Mvb $id
738 echo -e '\n\n##############################\n'
739 done | tee -a /tmp/frozen
740 }
741 frozenrm() {
742 local ids=()
743 while read -r line; do
744 printf '%s\n' "$line"
745 ids+=($(printf '%s\n' "$line" |gr frozen|awk '{print $3}'))
746 done < <(s mailq)
747 echo "sleeping for 2 in case you change your mind"
748 sleep 2
749 sudo exim -Mrm "${ids[@]}"
750 }
751
752 funce() {
753 # like -e for functions. returns on error.
754 # at the end of the function, disable with:
755 # trap ERR
756 trap 'echo "${BASH_COMMAND:+BASH_COMMAND=\"$BASH_COMMAND\" }
757 ${FUNCNAME:+FUNCNAME=\"$FUNCNAME\" }${LINENO:+LINENO=\"$LINENO\" }\$?=$?"
758 trap ERR
759 return' ERR
760 }
761
762 getdir () {
763 local help="Usage: getdir [--help] PATH
764 Output the directory of PATH, or just PATH if it is a directory."
765 if [[ $1 == --help ]]; then
766 echo "$help"
767 return 0
768 fi
769 if [[ $# -ne 1 ]]; then
770 echo "getdir error: expected 1 argument, got $#"
771 return 1
772 fi
773 if [[ -d $1 ]]; then
774 echo "$1"
775 else
776 local dir
777 dir="$(dirname "$1")"
778 if [[ -d $dir ]]; then
779 echo "$dir"
780 else
781 echo "getdir error: directory does not exist"
782 return 1
783 fi
784 fi
785 }
786
787 git_empty_branch() { # start an empty git branch. carefull, it deletes untracked files.
788 [[ $# == 1 ]] || { echo 'need a branch name!'; return 1;}
789 local root
790 root=$(gitroot) || return 1 # function to set gitroot
791 builtin cd "$root"
792 git symbolic-ref HEAD refs/heads/$1
793 rm .git/index
794 git clean -fdx
795 }
796
797 # shellcheck disable=SC2120
798 gitroot() {
799 local help="Usage: gitroot [--help]
800 Print the full path to the root of the current git repo
801
802 Handles being within a .git directory, unlike git rev-parse --show-toplevel,
803 and works in older versions of git which did not have that."
804 if [[ $1 == --help ]]; then
805 echo "$help"
806 return
807 fi
808 local p
809 p=$(git rev-parse --git-dir) || { echo "error: not in a git repo" ; return 1; }
810 [[ $p != /* ]] && p=$PWD
811 echo "${p%%/.git}"
812 }
813
814 g() {
815
816 # todo: patch emacs so it will look elsewhere. this is kinda sad:
817 # https://emacs.stackexchange.com/questions/4253/how-to-start-emacs-with-a-custom-user-emacs-directory
818
819 local args gdb=false
820
821 if [[ $EMACSDIR ]]; then
822 path-add "$EMACSDIR/lib-src" "$EMACSDIR/src"
823 fi
824
825 if [[ $DISPLAY ]]; then
826 args=-n
827 fi
828
829 if (( $# == 0 )); then
830 args+=" -c"
831 fi
832 # duplicate -c, but oh well
833 if ! pgrep -u $EUID emacsclient; then
834 if (( $# == 0 )) && type -p gdb &>/dev/null; then
835 gdb=true
836 else
837 args+=" -c"
838 fi
839 fi
840 if [[ $EMACSDIR ]]; then
841 # Alter the path here, otherwise the nfs mount gets triggered on the
842 # first path lookup when emacs is not being used.
843 PATH="$EMACSDIR/lib-src:$EMACSDIR/src:$PATH" EHOME=$HOME HOME=$EMACSDIR m emacsclient -a "" $args "$@"
844 else
845 if $gdb; then
846 # due to a bug, we cant debug from the start unless we get a new gdb
847 # https://sourceware.org/bugzilla/show_bug.cgi?id=24454
848 # m gdb -ex="set follow-fork-mode child" -ex=r -ex=quit --args emacs --daemon
849 m emacsclient -a "" $args "$@"
850 sleep 1
851 cd /a/opt/emacs-$(distro-name)$(distro-num)
852 s gdb -p $(pgrep -f 'emacs --daemon') -ex c
853 cd -
854 else
855 m emacsclient -a "" $args "$@"
856 fi
857 fi
858 }
859
860 # force terminal version
861 gn() {
862 g -n "$@"
863 }
864
865 gmacs() {
866 # quit will prompt if the program crashes.
867 gdb -ex=r -ex=quit --args emacs "$@"; r;
868 }
869
870 gdkill() {
871 # kill the emacs daemon
872 pk1 emacs --daemon
873 }
874
875 gr() {
876 grep -iIP --color=auto "$@" || return $?
877 }
878 grr() { # grep recursive
879 # Don't return 1 on nonmatch because this is meant to be
880 # interactive, not in a conditional.
881 if [[ ${#@} == 1 ]]; then
882 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -riIP --color=auto "$@" . || [[ $? == 1 ]]
883 else
884 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -riIP --color=auto "$@" || [[ $? == 1 ]]
885 fi
886 }
887 ccomp grep gr grr
888
889 rg() { grr "$@"; }
890 ccomp grep rg
891
892 hr() { # horizontal row. used to break up output
893 printf "$(tput setaf 5 2>/dev/null ||:)â–ˆ$(tput sgr0 2>/dev/null||:)%.0s" $(eval echo "{1..${COLUMNS:-60}}")
894 echo
895 }
896 # highlight
897 hl() {
898 local col input_len=0
899 for arg; do
900 input_len=$((input_len + 1 + ${#arg}))
901 done
902 col=$((60 - input_len))
903 printf "\e[1;97;41m%s" "$*"
904 if (( col > 0 )); then
905 printf "\e[1;97;41m \e[0m%.0s" $(eval echo "{1..${col}}")
906 fi
907 echo
908 }
909 hlm() { hl "$*"; "$@"; }
910
911 hrcat() { local f; for f; do [[ -f $f ]] || continue; hr; echo "$f"; cat "$f"; done }
912
913
914 # get latest hub and run it
915 # main command to use:
916 # hub pull-request --no-edit
917 # --no-edit means to use the first commit\'s message as the pull request message.
918 # If that fails, try doing
919 # hub pull-request --no-edit -b UPSTREAM_OWNER:branch
920 # where branch is usually master. it does the pr against your current branch.
921 #
922 # On first use, you input username/pass and it gets an oath token so you dont have to repeat
923 # it\'s at ~/.config/hub
924 hub() {
925 local up uptar updir p
926 p=/github/hub/releases/
927 up=https://github.com/$(curl -s https://github.com$p| grep -o $p'download/[^/]*/hub-linux-amd64[^"]*' | head -n1)
928 uptar=${up##*/}
929 updir=${uptar%.tgz}
930 if [[ ! -e /a/opt/$updir ]]; then
931 rm -rf /a/opt/hub-linux-amd64*
932 wget -P /a/opt $up
933 tar -C /a/opt -zxf /a/opt/$uptar
934 rm -f /a/opt/$uptar
935 fi
936 if ! which hub &>/dev/null; then
937 sudo /a/opt/$updir/install
938 fi
939
940 # save token across computers
941 if [[ ! -L ~/.config/hub ]]; then
942 if [[ -e ~/.config/hub ]]; then
943 mv ~/.config/hub /p/c/subdir_files/.config/
944 fi
945 if [[ -e /p/c/subdir_files/.config/hub ]]; then
946 conflink
947 fi
948 fi
949 command hub "$@"
950 }
951
952 i() { git "$@"; }
953 ccomp git i
954
955 ic() {
956 # fast commit all
957 git commit -am "$*"
958 }
959
960
961 ifn() {
962 # insensitive find
963 find -L . -not \( -name .svn -prune -o -name .git -prune \
964 -o -name .hg -prune -o -name .editor-backups -prune \
965 -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
966 }
967
968 ifd() {
969 # insensitive find directory
970 find -L . -type d -not \( -name .svn -prune -o -name .git -prune \
971 -o -name .hg -prune -o -name .editor-backups -prune \
972 -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
973 }
974
975
976 ipdrop() {
977 sudo iptables -A INPUT -s $1 -j DROP
978 }
979
980
981 istext() {
982 grep -Il "" "$@" &>/dev/null
983 }
984
985 jtail() {
986 journalctl -n 10000 -f "$@"
987 }
988 jr() { journalctl "$@" ; }
989 jrf() { journalctl -f "$@" ; }
990 jru() {
991 journalctl -u exim4 _SYSTEMD_INVOCATION_ID=$(systemctl show -p InvocationID --value $1)
992 }
993
994 l() {
995 if [[ $PWD == /[iap] ]]; then
996 command ls -A --color=auto -I lost+found "$@"
997 else
998 command ls -A --color=auto "$@"
999 fi
1000 }
1001
1002 lcn() { locate -i "*$**"; }
1003
1004 lg() { LC_COLLATE=C.UTF-8 ll --group-directories-first "$@"; }
1005
1006 lt() { ll -tr "$@"; }
1007
1008 lld() { ll -d "$@"; }
1009
1010 ccomp ls l lg lt lld ll
1011
1012 # low recursively
1013 lowr() {
1014 local f dirs i a
1015 local -a all
1016 for dirs in false true; do
1017 for f; do
1018 if [[ -d $f ]]; then
1019 all=("$f"/**)
1020 # reverse the order to rename the nested dirs first.
1021 # note: 0 element is the dir itself
1022 for ((i=${#all[@]}-1; i>=1; i--)); do
1023 a="${all[i]}"
1024 if $dirs && [[ -d $a ]]; then
1025 # e dirs low "$a" # debug
1026 low "$a"
1027 elif ! $dirs && [[ ! -d $a && -e $a ]]; then
1028 # debug
1029 # e not dirs low "$a" # debug
1030 low "$a"
1031 fi
1032 done
1033 fi
1034 # just rename all the top level args on the second pass
1035 if $dirs; then
1036 # e final dirs low "$f" # debug
1037 low "$f"
1038 fi
1039 done
1040 done
1041 }
1042
1043 low() { # make filenames lowercase, remove bad chars
1044 local arg new dir f
1045 for arg; do
1046 arg="${arg%%+(/)}" # remove trailing slashes. assumes we have extglob on.
1047 dir="${arg%/*}"
1048 if (( ${#dir} == ${#arg} )); then
1049 dir=.
1050 fi
1051 f="${arg##*/}"
1052 new="${f,,}" # downcase
1053 new="${new//[^[:alnum:]._-]/_}" # sub bad chars
1054 new="${new#"${new%%[[:alnum:]]*}"}" # remove leading/trailing non-alnum
1055 new="${new%"${new##*[[:alnum:]]}"}"
1056 # remove bad underscores, like __ and _._
1057 new=$(echo $new | sed -r 's/__+/_/g;s/_+([.-])|([.-])_+/\1/g')
1058 safe_rename "$dir/$f" "$dir/$new" || return 1
1059 done
1060 return 0
1061 }
1062
1063 lower() { # make first letter of filenames lowercase.
1064 local x
1065 for x in "$@"; do
1066 if [[ ${x::1} == [A-Z] ]]; then
1067 y=$(tr '[:upper:]' '[:lower:]' <<<"${x::1}")"${x:1}"
1068 safe_rename "$x" "$y" || return 1
1069 fi
1070 done
1071 }
1072
1073
1074 k() { # history search
1075 grep -iP --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | tail -n 80 || [[ $? == 1 ]];
1076 }
1077 ks() { # history search
1078 grep -P --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | uniq || [[ $? == 1 ]];
1079 }
1080 ccomp grep k ks
1081
1082
1083 make-targets() {
1084 # show make targets, via http://stackoverflow.com/questions/3063507/list-goals-targets-in-gnu-make
1085 make -qp | awk -F':' '/^[a-zA-Z0-9][^$#\/\t=]*:([^=]|$)/ {split($1,A,/ /);for(i in A)print A[i]}'
1086 }
1087
1088 mkc() {
1089 mkdir "$1"
1090 c "$1"
1091 }
1092 ccomp mkdir mkc
1093
1094 mkct() {
1095 mkc $(mktemp -d)
1096 }
1097
1098 mkt() { # mkdir and touch file
1099 local path="$1"
1100 mkdir -p "$(dirname "$path")"
1101 touch "$path"
1102 }
1103
1104 # shellcheck disable=SC2032
1105 mkdir() { command mkdir -p "$@"; }
1106
1107 nags() {
1108 # https://github.com/HenriWahl/Nagstamon/issues/357
1109 if ! pgrep -f /usr/lib/notification-daemon/notification-daemon >/dev/null; then
1110 /usr/lib/notification-daemon/notification-daemon &
1111 fi
1112 /usr/bin/nagstamon &
1113 }
1114
1115 nmt() {
1116 s nmtui-connect "$@"
1117 }
1118
1119 nopanic() {
1120 # shellcheck disable=SC2024
1121 sudo tee -a /var/log/exim4/paniclog-archive </var/log/exim4/paniclog; sudo truncate -s0 /var/log/exim4/paniclog
1122 }
1123
1124 p8() { ping "$@" 8.8.8.8; }
1125 p6() { ping6 "$@" 2001:4860:4860::8888; }
1126
1127 pkx() { # package extract
1128 local pkg cached tmp f
1129 c $(mktemp -d)
1130 pkg=$1
1131 # shellcheck disable=SC2012
1132 cached=$(ls -t /var/cache/apt/archives/$pkg* | tail -n1 2>/dev/null) ||:
1133 if [[ $cached ]]; then
1134 cp $cached .
1135 else
1136 aptitude download $pkg || return 1
1137 fi
1138 tmp=(*); f=${tmp[0]} # only 1 expected
1139 ex $f
1140 rm -f $f
1141 }
1142
1143 # pgrep and kill
1144 pk1() {
1145 local pid
1146 pid=($(pgrep -f "$*"))
1147 case ${#pid[@]} in
1148 1)
1149 # shellcheck disable=SC2128
1150 {
1151 ps -F $pid
1152 m kill $pid
1153 }
1154 ;;
1155 0) echo "no pid found" ;;
1156 *)
1157 ps -F ${pid[@]}
1158 ;;
1159 esac
1160 }
1161
1162 psg () {
1163 local x y help
1164 help="Usage: psg [--help] GREP_ARGS
1165 grep ps and output in a nice format"
1166 if [[ $1 == --help ]]; then
1167 echo "$help"
1168 return
1169 fi
1170 x=$(ps -eF)
1171 # final grep is because some commands tend to have a lot of trailing spaces
1172 y=$(echo "$x" | grep -iP "$@" | grep -o '.*[^ ]') ||:
1173 if [[ $y ]]; then
1174 echo "$x" | head -n 1 || [[ $? == 141 ]]
1175 echo "$y"
1176 fi
1177 }
1178
1179 pubip() { curl -4s https://icanhazip.com; }
1180 pubip6() { curl -6s https://icanhazip.com; }
1181 whatismyip() { pubip; }
1182
1183
1184 q() { # start / launch a program in the backround and redir output to null
1185 "$@" &> /dev/null &
1186 }
1187
1188 # shellcheck disable=SC2120
1189 r() {
1190 if [[ $HISTFILE ]]; then
1191 history -a # save history
1192 fi
1193 trap ERR # this avoids a segfault
1194 exit ${1:0}
1195 # i had this redir, not sure why
1196 # exit "$@" 2>/dev/null
1197 }
1198
1199 # scp is insecure and deprecated.
1200 scp() {
1201 rsync --inplace "$@"
1202 }
1203
1204 randport() {
1205 # available high ports are 1024-65535,
1206 # but lets skip things that are more likely to be in use
1207 python3 <<'EOF'
1208 import secrets
1209 print(secrets.SystemRandom().randrange(10002,65500))
1210 EOF
1211 }
1212
1213 # reapply bashrc
1214 reb() {
1215 source ~/.bashrc
1216 }
1217
1218 rl() {
1219 readlink -f "$@"
1220 }
1221 ccomp readlink rl
1222
1223 rsd() {
1224 # rsync, root is required to keep permissions right.
1225 # rsync --archive --human-readable --verbose --itemize-changes --checksum \(-ahvic\) \
1226 # --no-times --delete
1227 # basically, make an exact copy, use checksums instead of file times to be more accurate
1228 rsync -ahvic --delete "$@"
1229 }
1230 rsa() {
1231 # like rlu, but dont delete files on the target end which
1232 # do not exist on the original end.
1233 rsync -ahvic "$@"
1234 }
1235 rst() {
1236 # rl without preserving modification time.
1237 rsync -ahvic --delete --no-t "$@"
1238 }
1239 rsu() { # [OPTS] HOST PATH
1240 # eg. rlu -opts frodo /testpath
1241 # relative paths will expanded with readlink -f.
1242 opts=("${@:1:$#-2}") # 1 to last -2
1243 path="${*:$#}" # last
1244 host="${*:$#-1:1}" # last -1
1245 if [[ $path == .* ]]; then
1246 path=$(readlink -f $path)
1247 fi
1248 # rync here uses checksum instead of time so we dont mess with
1249 # unison relying on time as much. g is for group, same reason
1250 # to keep up with unison.
1251 m s rsync -rlpchviog --relative "${opts[@]}" "$path" "root@$host:/";
1252 }
1253 ccomp rsync rsd rsa rst rsu
1254
1255 resolvcat() {
1256 local f
1257 if [[ $(systemctl is-active nscd ||:) != inactive ]]; then
1258 m s nscd -i hosts
1259 fi
1260 f=/etc/resolv.conf
1261 echo $f:; ccat $f
1262 hr; s ss -lpn 'sport = 53'
1263 if systemctl is-enabled dnsmasq &>/dev/null || [[ $(systemctl is-active dnsmasq ||:) != inactive ]]; then
1264 # this will fail is dnsmasq is failed
1265 hr; m ser status dnsmasq | cat || :
1266 f=/etc/dnsmasq.conf
1267 hr; echo $f:; ccat $f
1268 hr; m grr '^ *(servers-file|server) *=|^ *no-resolv *$' /etc/dnsmasq.conf /etc/dnsmasq.d
1269 f=/etc/dnsmasq-servers.conf
1270 hr; echo $f:; ccat $f
1271 fi
1272 hr
1273 echo /etc/nsswitch.conf:
1274 grep '^ *hosts:' /etc/nsswitch.conf
1275 if systemctl is-enabled systemd-resolved &>/dev/null || [[ $(systemctl is-active systemd-resolved ||:) != inactive ]]; then
1276 hr; m ser status systemd-resolved | cat || :
1277 hr; m systemd-resolve --status | cat
1278 fi
1279
1280 }
1281 rcat() {
1282 resolvcat | less
1283 }
1284 reresolv() {
1285 if [[ $(systemctl is-active nscd ||:) != inactive ]]; then
1286 m ser stop nscd
1287 sleep .5
1288 m ser start nscd
1289 m sudo nscd -i hosts
1290 fi
1291 if [[ $(systemctl is-active dnsmasq ||:) != inactive ]]; then
1292 m sudo systemctl restart dnsmasq
1293 fi
1294 if [[ $(systemctl is-active systemd-resolved ||:) != inactive ]]; then
1295 m sudo systemctl restart systemd-resolved
1296 fi
1297 if type -P resolvectl &>/dev/null; then
1298 resolvectl flush-caches
1299 fi
1300 }
1301
1302 rmstrips() {
1303 ssh fencepost head -n 300 /gd/gnuorg/EventAndTravelInfo/rms-current-trips.txt | less
1304 }
1305
1306 s() {
1307 # background
1308 # I use a function because otherwise we cant use in a script,
1309 # cant assign to variable.
1310 #
1311 # note: gksudo is recommended for X apps because it does not set the
1312 # home directory to the same, and thus apps writing to ~ fuck things up
1313 # with root owned files.
1314 #
1315 if [[ $EUID != 0 || $1 == -* ]]; then
1316 # shellcheck disable=SC2034
1317 SUDOD="$PWD" command sudo -i "$@"
1318 DID_SUDO=true
1319 else
1320 "$@"
1321 fi
1322 }
1323 sb() { # sudo bash -c
1324 # use sb instead of s is for sudo redirections,
1325 # eg. sb 'echo "ok fine" > /etc/file'
1326 # shellcheck disable=SC2034
1327 local SUDOD="$PWD"
1328 sudo -i bash -c "$@"
1329 }
1330 ccomp sudo s sb
1331
1332 safe_rename() { # warn and dont rename if file exists.
1333 # mv -n exists, but it\'s silent
1334 if [[ $# != 2 ]]; then
1335 echo safe_rename error: $# args, need 2 >2
1336 return 1
1337 fi
1338 if [[ $1 != "$2" ]]; then # yes, we want to silently ignore this
1339 if [[ -e $2 || -L $2 ]]; then
1340 echo "Cannot rename $1 to $2 as it already exists."
1341 else
1342 mv -vi "$1" "$2"
1343 fi
1344 fi
1345 }
1346
1347
1348
1349 sd() {
1350 sudo dd status=none of="$1"
1351 }
1352
1353 ser() {
1354 if type -p systemctl &>/dev/null; then
1355 s systemctl "$@"
1356 else
1357 if (( $# >= 3 )); then
1358 echo iank: ser expected 2 or less arguments
1359 return 1
1360 fi
1361 s service $2 $1
1362 fi
1363 }
1364 seru() { systemctl --user "$@"; }
1365 # like restart, but do nothing if its not already started
1366 srestart() {
1367 local service=$1
1368 if [[ $(s systemctl --no-pager show -p ActiveState $service ) == ActiveState=active ]]; then
1369 systemctl restart $service
1370 fi
1371 }
1372
1373 setini() { # set a value in a .ini style file
1374 key="$1" value="$2" section="$3" file="$4"
1375 if [[ -s $file ]]; then
1376 sed -ri -f - "$file" <<EOF
1377 # remove existing keys
1378 / *\[$section\]/,/^ *\[[^]]+\]/{/^\s*$key[[:space:]=]/d}
1379 # add key
1380 /^\s*\[$section\]/a $key=$value
1381 # from section to eof, do nothing
1382 /^\s*\[$section\]/,\$b
1383 # on the last line, if we haven't found section yet, add section and key
1384 \$a [$section]\\
1385 $key=$value
1386 EOF
1387 else
1388 cat >"$file" <<EOF
1389 [$section]
1390 $key=$value
1391 EOF
1392 fi
1393 }
1394
1395 sgo() { # service go
1396 service=$1
1397 ser restart $service || return 1
1398 if type -p systemctl &>/dev/null; then
1399 ser enable $service
1400 fi
1401 }
1402 soff () {
1403 for service; do
1404 # ignore services that dont exist
1405 if systemctl cat $service &>/dev/null; then
1406 ser stop $service;
1407 ser disable $service
1408 fi
1409 done
1410 }
1411
1412 sgu() {
1413 systemctl list-unit-files | rg "$@"
1414 }
1415
1416
1417 sk() {
1418 # 2029: "unescaped, this expands on the client side." yes, I know how ssh works
1419 # 2164: "Use 'cd ... || exit' or 'cd ... || return' in case cd fails." i have automatic error handling
1420 # 2086: unquoted $var
1421 # 2046: unquoted $(cmd)
1422 # 2068: Double quote array expansions to avoid re-splitting elements.
1423 # 2119: Functions with optional args get bad warnings when none are passed.
1424 # 2033: too many false positives for thing that will never work, passing shell function to find.
1425 # i had -x as an arg, but debian testing(stretch) doesn\'t support it
1426 shellcheck -x -e 2029,2164,2086,2046,2068,2119,2033 "$@" || return $?
1427 # had this before. not sure what it is 2119
1428 }
1429
1430
1431 # sl: ssh, but firsh rsync our bashrc and related files to a special
1432 # directory on the remote host if needed.
1433
1434 # Some environment variables and files need to be setup for this to work
1435 # (mine are set at the beginning of this file)
1436
1437 # SL_FILES_DIR: Environment variable. Path to folder which should at
1438 # least have a .bashrc file or symlink. This dir will be rsynced to ~ on
1439 # remote hosts (top level symlinks are resolved) unless the host already
1440 # has a $SL_FILES_DIR/.bashrc. In that case, we assume it is a host you
1441 # control and sync files to separately and already has the ~/.bashrc you
1442 # want. The remote bash will also take its .inputrc config from this
1443 # folder (default of not existing is fine). Mine looks like this:
1444 # https://iankelling.org/git/?p=distro-setup;a=tree;f=sl/.iank
1445
1446 # SL_INFO_DIR: Environment variable. This folder stores info about what
1447 # we detected on the remote system and when we last synced. It will be created
1448 # if it does not exist. Sometimes you may want to forget about a
1449 # remote system, you can use sl --rsync, or the function for that slr
1450 # below.
1451
1452 # SL_TEST_CMD: Env var. Meant to be used to vary the files synced
1453 # depending on the remote host. Run this string on the remote host the
1454 # first time sl is run (or if we run slr). The result is passed to
1455 # SL_TEST_HOOK. For example,
1456 # export SL_TEST_CMD=". /etc/os-release ; echo \${VERSION//[^a-zA-Z0-9]/}"
1457
1458 # SL_TEST_HOOK: Env var. It is run as $SL_TEST_HOOK. This can set
1459 # $SL_FILES_DIR to vary the files synced.
1460
1461 # SL_RSYNC_ARGS: Env var. String of arguments passed to rsync. For
1462 # example to exclude files within a directory. Note, excluded
1463 # files wont be deleted on rsync, you can add --delete-excluded
1464 # to the rsync command if that is desired.
1465
1466 # SL_SSH_ARGS: Env var. Default arguments passed to ssh.
1467
1468 # For when ~/.bashrc is already customized on the remote server, you
1469 # might find it problematic that ~/.bashrc is sourced for ALL ssh
1470 # commands, even in scripts. This paragraph is all about that. bash
1471 # scripts dont source ~/.bashrc, but call ssh in scripts and you get
1472 # ~/.bashrc. You dont want this. .bashrc is meant for interactive shells
1473 # and if you customize it, probably has bugs from time to time. This is
1474 # bad. Here's how I fix it. I have a special condition to "return" in my
1475 # .bashrc for noninteractive ssh shells (copy that code). Then use this
1476 # function or similar that passes LC_USEBASHRC=t when sshing and I want
1477 # my bashrc. Also, I don't keep most of my bashrc in .bashrc, i source a
1478 # separate file because even if I return early on, the whole file gets
1479 # parsed which can fail if there is a syntax error.
1480 sl() {
1481 # Background on LC_USEBASHRC var (no need to read if you just want to
1482 # use this function): env variables sent across ssh are strictly
1483 # limited, but we get LC_* at least in debian based machines, so we
1484 # just make that * be something no normal program would use. Note, on
1485 # hosts that dont allow LC_* I start an inner shell with LC_USEBASHRC
1486 # set, and the inner shell also allows running a nondefault
1487 # .bashrc. This means the outer shell still ran the default .bashrc,
1488 # but that is the best we can do.
1489
1490 local now args remote dorsync haveinfo tmpa sshinfo tmp tmp2 type info_sec force_rsync \
1491 sync_dirname testcmd extra_info testbool files_sec sl_test_cmd sl_test_hook
1492 declare -a args tmpa
1493
1494 args=($SL_SSH_ARGS)
1495
1496 # ssh [-1246Antivivisectionist] [-b bind_address] [-c cipher_spec] [-D [bind_address:]port]
1497 # [-E log_file] [-e escape_char] [-F configfile] [-I pkcs11] [-i identity_file] [-L address]
1498 # [-l login_name] [-m mac_spec] [-O ctl_cmd] [-o option] [-p port] [-Q query_option]
1499 # [-R address] [-S ctl_path] [-W host:port] [-w local_tun[:remote_tun]] [user@]hostname
1500 # [command]
1501
1502 # ssh [-46AaCfGgKkMNnqsTtVvXxYy] [-b bind_address] [-c cipher_spec]
1503 # [-D [bind_address:]port] [-E log_file] [-e escape_char]
1504 # [-F configfile] [-I pkcs11] [-i identity_file]
1505 # [-J [user@]host[:port]] [-L address] [-l login_name] [-m mac_spec]
1506 # [-O ctl_cmd] [-o option] [-p port] [-Q query_option] [-R address]
1507 # [-S ctl_path] [-W host:port] [-w local_tun[:remote_tun]]
1508
1509 force_rsync=false
1510 if [[ $1 == --rsync ]]; then
1511 force_rsync=true
1512 shift
1513 fi
1514
1515 sl_test_cmd=$SL_TEST_CMD
1516 sl_test_hook=$SL_TEST_HOOK
1517 sl_rsync_args=$SL_RSYNC_ARGS
1518 while [[ $1 ]]; do
1519 case "$1" in
1520 --rsync)
1521 force_rsync=true
1522 ;;
1523 --sl-test-cmd)
1524 sl_test_cmd="$2"
1525 shift
1526 ;;
1527 --sl-test-hook)
1528 sl_test_hook="$2"
1529 shift
1530 ;;
1531 --sl-rsync-args)
1532 sl_rsync_args="$2"
1533 shift
1534 ;;
1535 *)
1536 break
1537 ;;
1538 esac
1539 shift
1540 done
1541
1542 while [[ $1 ]]; do
1543 case "$1" in
1544 # note we dont support things like -4oOption
1545 -[46AaCfGgKkMNnqsTtVvXxYy]*)
1546 args+=("$1"); shift
1547 ;;
1548 -[bcDEeFIiJLlmOopQRSWw]*)
1549 # -oOption etc is valid
1550 if (( ${#1} >= 3 )); then
1551 args+=("$1"); shift
1552 else
1553 args+=("$1" "$2"); shift 2
1554 fi
1555 ;;
1556 *)
1557 break
1558 ;;
1559 esac
1560 done
1561 remote="$1"
1562 if [[ ! $remote ]]; then
1563 echo $0: error hostname required >&2
1564 return 1
1565 fi
1566 shift
1567
1568 if [[ ! $SL_INFO_DIR ]]; then
1569 echo error: missing '$SL_INFO_DIR' env var >&2
1570 return 1
1571 fi
1572
1573 now=$(date +%s)
1574 dorsync=false
1575 haveinfo=false
1576 tmpa=($SL_INFO_DIR/???????????"$remote")
1577 sshinfo=${tmpa[0]}
1578 if [[ -e $sshinfo ]]; then
1579 if $force_rsync; then
1580 rm -f $sshinfo
1581 else
1582 haveinfo=true
1583 fi
1584 fi
1585 if $haveinfo; then
1586 tmp=${sshinfo[0]##*/}
1587 tmp2=${tmp::11}
1588 type=${tmp2: -1}
1589 extra_info=$(cat $sshinfo)
1590 else
1591 # we test for string to know ssh succeeded
1592 testbool="test -e $SL_FILES_DIR/.bashrc -a -L .bashrc -a -v LC_USEBASHRC"
1593 testcmd="if $testbool; then printf y; else printf n; fi"
1594 if ! tmp=$(LC_USEBASHRC=y command ssh "${args[@]}" "$remote" "$testcmd; $sl_test_cmd"); then
1595 echo failed sl test. doing plain ssh -v
1596 command ssh -v "${args[@]}" "$remote"
1597 fi
1598 if [[ $tmp == y* ]]; then
1599 type=a
1600 else
1601 dorsync=true
1602 type=b
1603 fi
1604 extra_info="${tmp:1}"
1605 fi
1606 if [[ $sl_test_hook ]]; then
1607 RSYNC_RSH="ssh ${args[*]}" $sl_test_hook "$extra_info" "$remote"
1608 fi
1609
1610 if $haveinfo && [[ $type == b ]]; then
1611 info_sec=${tmp::10}
1612 read files_sec _ < <(find -L $SL_FILES_DIR -printf "%T@ %p\n" | sort -nr || [[ $? == 141 || ${PIPESTATUS[0]} == 32 ]] )
1613 files_sec=${files_sec%%.*}
1614 if (( files_sec > info_sec )); then
1615 dorsync=true
1616 rm -f $sshinfo
1617 fi
1618 fi
1619
1620 sync_dirname=${SL_FILES_DIR##*/}
1621
1622 if [[ ! $SL_FILES_DIR ]]; then
1623 echo error: missing '$SL_FILES_DIR' env var >&2
1624 return 1
1625 fi
1626
1627 if $dorsync; then
1628 RSYNC_RSH="ssh ${args[*]}" m rsync -rptL --delete $sl_rsync_args $SL_FILES_DIR "$remote":
1629 fi
1630 if $dorsync || ! $haveinfo; then
1631 sshinfo=$SL_INFO_DIR/$now$type"$remote"
1632 [[ -e $SL_INFO_DIR ]] || mkdir -p $SL_INFO_DIR
1633 printf "%s\n" "$extra_info" >$sshinfo
1634 chmod 666 $sshinfo
1635 fi
1636 if [[ $type == b ]]; then
1637 if (( ${#@} )); then
1638 # Theres a couple ways to pass arguments, im not sure whats best,
1639 # but relying on bash 4.4+ escape quoting seems most reliable.
1640 command ssh "${args[@]}" "$remote" \
1641 LC_USEBASHRC=t bash -c '.\ '$sync_dirname'/.bashrc\;"\"\$@\""' bash ${@@Q}
1642 elif [[ ! -t 0 ]]; then
1643 # This case is when commands are being piped to ssh.
1644 # Normally, no bashrc gets sourced.
1645 # But, since we are doing all this, lets source it because we can.
1646 cat <(echo . $sync_dirname/.bashrc) - | command ssh "${args[@]}" "$remote" LC_USEBASHRC=t bash
1647 else
1648 command ssh -t "${args[@]}" "$remote" LC_USEBASHRC=t INPUTRC=$sync_dirname/.inputrc bash --rcfile $sync_dirname/.bashrc
1649 fi
1650 else
1651 if [[ -t 0 ]]; then
1652 LC_USEBASHRC=t command ssh "${args[@]}" "$remote" ${@@Q}
1653 else
1654 command ssh "${args[@]}" "$remote" LC_USEBASHRC=t bash
1655 fi
1656 fi
1657 # this function inspired from https://github.com/Russell91/sshrc
1658 }
1659
1660 slr() {
1661 sl --rsync "$@"
1662 }
1663 sss() { # ssh solo
1664 sl -oControlMaster=no -oControlPath=/ "$@"
1665 }
1666 # kill off old shared socket then ssh
1667 ssk() {
1668 m ssh -O exit "$@" || [[ $? == 255 ]]
1669 m sl "$@"
1670 }
1671 ccomp ssh sl slr sss ssk
1672 # plain ssh
1673 ssh() {
1674 if [[ $TERM == alacritty || $TERM == xterm-kitty ]]; then
1675 TERM=xterm-256color LC_USEBASHRC=t command ssh "$@"
1676 else
1677 LC_USEBASHRC=t command ssh "$@"
1678 fi
1679 }
1680
1681
1682 slog() {
1683 # log with script. timing is $1.t and script is $1.s
1684 # -l to save to ~/typescripts/
1685 # -t to add a timestamp to the filenames
1686 local logdir do_stamp arg_base
1687 (( $# >= 1 )) || { echo "arguments wrong"; return 1; }
1688 logdir="/a/dt/"
1689 do_stamp=false
1690 while getopts "lt" option
1691 do
1692 case $option in
1693 l ) arg_base=$logdir ;;
1694 t ) do_stamp=true ;;
1695 esac
1696 done
1697 shift $((OPTIND - 1))
1698 arg_base+=$1
1699 [[ -e $logdir ]] || mkdir -p $logdir
1700 $do_stamp && arg_base+=$(date +%F.%T%z)
1701 script -t $arg_base.s 2> $arg_base.t
1702 }
1703 splay() { # script replay
1704 #logRoot="$HOME/typescripts/"
1705 #scriptreplay "$logRoot$1.t" "$logRoot$1.s"
1706 scriptreplay "$1.t" "$1.s"
1707 }
1708
1709 sr() {
1710 # sudo redo. be aware, this command may not work right on strange distros or earlier software
1711 if [[ $# == 0 ]]; then
1712 sudo -E bash -c -l "$(history -p '!!')"
1713 else
1714 echo this command redos last history item. no argument is accepted
1715 fi
1716 }
1717
1718 srm () {
1719 # with -ll, less secure but faster.
1720 command srm -ll "$@"
1721 }
1722
1723 srun() {
1724 scp $2 $1:/tmp
1725 ssh $1 /tmp/${2##*/} $(printf "%q\n" "${@:2}")
1726 }
1727
1728
1729 swap() {
1730 local tmp
1731 tmp=$(mktemp)
1732 mv $1 $tmp
1733 mv $2 $1
1734 mv $tmp $2
1735 }
1736
1737 tclock() { # terminal clock
1738 local x
1739 clear
1740 date +%l:%_M
1741 len=60
1742 # this goes to full width
1743 #len=${1:-$((COLUMNS -7))}
1744 x=1
1745 while true; do
1746 if (( x == len )); then
1747 end=true
1748 d="$(date +%l:%_M) "
1749 else
1750 end=false
1751 d=$(date +%l:%M:%_S)
1752 fi
1753 echo -en "\r"
1754 echo -n "$d"
1755 for ((i=0; i<x; i++)); do
1756 if (( i % 6 )); then
1757 echo -n _
1758 else
1759 echo -n .
1760 fi
1761 done
1762 if $end; then
1763 echo
1764 x=1
1765 else
1766 x=$((x+1))
1767 fi
1768 sleep 5
1769 done
1770 }
1771
1772
1773 te() {
1774 # test existence / exists
1775 local ret=0
1776 for x in "$@"; do
1777 [[ -e "$x" || -L "$x" ]] || ret=1
1778 done
1779 return $ret
1780 }
1781
1782 psoff() {
1783 # normally, i would just execute these commands in the function.
1784 # however, DEBUG is not inherited, so we need to run it outside a function.
1785 # And we want to run set -x afterwards to avoid spam, so we cram everything
1786 # in here, and then it will run after this function is done.
1787 PROMPT_COMMAND='trap DEBUG; unset PROMPT_COMMAND; PS1="\w \$ "'
1788 }
1789 pson() {
1790 PROMPT_COMMAND=prompt-command
1791 if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
1792 trap 'settitle "$BASH_COMMAND"' DEBUG
1793 fi
1794 }
1795
1796 tx() { # toggle set -x, and the prompt so it doesnt spam
1797 if [[ $- == *x* ]]; then
1798 set +x
1799 pson
1800 else
1801 psoff
1802 fi
1803 }
1804
1805 psnetns() {
1806 # show all processes in the network namespace $1.
1807 # blank entries appear to be subprocesses/threads
1808 local x netns
1809 netns=$1
1810 ps -w | head -n 1
1811 sudo find -L /proc/[1-9]*/task/*/ns/net -samefile /run/netns/$netns | cut -d/ -f5 | \
1812 while read -r l; do
1813 x=$(ps -w --no-headers -p $l);
1814 if [[ $x ]]; then echo "$x"; else echo $l; fi;
1815 done
1816 }
1817
1818 m() { printf "%s\n" "$*"; "$@"; }
1819
1820 uptime() {
1821 if type -p uprecords &>/dev/null; then
1822 uprecords -B
1823 else
1824 command uptime
1825 fi
1826 }
1827
1828 virshrm() {
1829 for x in "$@"; do virsh destroy "$x"; virsh undefine "$x"; done
1830 }
1831
1832 vm-set-listen(){
1833 local t
1834 t=$(mktemp)
1835 local vm=$1
1836 local ip=$2
1837 sudo virsh dumpxml $vm | sed -r "s/(<listen.*address=')([^']+)/\1$ip/" | \
1838 sed -r "s/listen='[^']+/listen='$ip/"> $t
1839 sudo virsh undefine $vm
1840 sudo virsh define $t
1841 }
1842
1843
1844 vmshare() {
1845 vm-set-listen $1 0.0.0.0
1846 }
1847
1848
1849 vmunshare() {
1850 vm-set-listen $1 127.0.0.1
1851 }
1852
1853 myiwscan() {
1854 # find input, copy to pattern space, when we find the first field, print the copy in different order without newlines.
1855 # instead of using labels, we could just match a line and group, eg: /signal:/,{s/signal:(.*)/\1/h}
1856 sudo iw dev wls1 scan | sed -rn "
1857 s/^\Wcapability: (.*)/\1/;Ta;h;b
1858 :a;s/^\Wsignal: -([^.]+).*/\1/;Tb;H;b
1859 # padded to min width of 20
1860 :b;s/\WSSID: (.*)/\1 /;T;s/^(.{20}(.*[^ ])?) */\1/;H;g;s/(.*)\n(.*)\n(.*)/\2 \3 \1/gp;b
1861 "|sort -r
1862 }
1863
1864 # * misc stuff
1865
1866
1867 # temporary variables to test colorization
1868 # some copied from gentoo /etc/bash/bashrc,
1869 use_color=false
1870 # dircolors --print-database uses its own built-in database
1871 # instead of using /etc/DIR_COLORS. Try to use the external file
1872 # first to take advantage of user additions.
1873 safe_term=${TERM//[^[:alnum:]]/?} # sanitize TERM
1874 match_lhs=""
1875 [[ -f ~/.dir_colors ]] && match_lhs="${match_lhs}$(<~/.dir_colors)"
1876 [[ -f /etc/DIR_COLORS ]] && match_lhs="${match_lhs}$(</etc/DIR_COLORS)"
1877 [[ -z ${match_lhs} ]] \
1878 && type -P dircolors >/dev/null \
1879 && match_lhs=$(dircolors --print-database)
1880 # test if our $TERM is in the TERM values in dircolor
1881 [[ $'\n'${match_lhs} == *$'\n'"TERM "${safe_term}* ]] && use_color=true
1882
1883
1884 if ${use_color} && [[ $- == *i* ]]; then
1885
1886 term_bold="$(tput bold)"
1887 term_red="$(tput setaf 1)"
1888 term_green="$(tput setaf 2)"
1889 term_yellow="$(tput setaf 3)"
1890 term_purple="$(tput setaf 5)"
1891 term_nocolor="$(tput sgr0)" # no font attributes
1892
1893 # unused so far. commented for shellcheck
1894 # term_underl="$(tput smul)"
1895 # term_blue="$(tput setaf 4)"
1896 # term_cyan="$(tput setaf 6)"
1897
1898 fi
1899 # Try to keep environment pollution down, EPA loves us.
1900 unset safe_term match_lhs use_color
1901
1902 # * prompt
1903
1904
1905 if [[ $- == *i* ]]; then
1906
1907 # this needs to come before next ps1 stuff
1908 # this stuff needs bash 4, feb 2009,
1909 # old enough to no longer condition on $BASH_VERSION anymore
1910 shopt -s autocd
1911 shopt -s dirspell
1912 PS1='\w'
1913 if [[ $- == *i* ]] && [[ ! $LC_INSIDE_EMACS ]]; then
1914 PROMPT_DIRTRIM=2
1915 bind -m vi-command B:shell-backward-word
1916 bind -m vi-command W:shell-forward-word
1917 fi
1918
1919 if [[ $SSH_CLIENT || $SUDO_USER ]]; then
1920 unset PROMPT_DIRTRIM
1921 PS1="\h:$PS1"
1922 fi
1923
1924 # emacs terminal has problems if this runs slowly,
1925 # so I've thrown a bunch of things at the wall to speed it up.
1926 prompt-command() {
1927 local return=$? # this MUST COME FIRST
1928 local ps_char ps_color
1929 unset IFS
1930
1931 if [[ $HISTFILE ]]; then
1932 history -a # save history
1933 fi
1934
1935 # assigned in brc2
1936 # shellcheck disable=SC1303
1937 if [[ $jr_pid ]]; then
1938 if [[ -e /proc/$jr_pid ]]; then
1939 kill $jr_pid
1940 fi
1941 unset jr_pid
1942 fi
1943
1944 case $return in
1945 0) ps_color="$term_purple"
1946 ps_char='\$'
1947 ;;
1948 1) ps_color="$term_green"
1949 ps_char="$return \\$"
1950 ;;
1951 *) ps_color="$term_yellow"
1952 ps_char="$return \\$"
1953 ;;
1954 esac
1955 if [[ ! -O . ]]; then # not owner
1956 if [[ -w . ]]; then # writable
1957 ps_color="$term_bold$term_red"
1958 else
1959 ps_color="$term_bold$term_green"
1960 fi
1961 fi
1962
1963 # faster than sourceing the file im guessing
1964 if [[ -e /dev/shm/iank-status && ! -e /tmp/quiet-status ]]; then
1965 eval $(< /dev/shm/iank-status)
1966 fi
1967 if [[ ! $SSH_CLIENT && $MAIL_HOST != "$HOSTNAME" ]]; then
1968 ps_char="@ $ps_char"
1969 fi
1970 # We could test if sudo is active with sudo -nv
1971 # but then we get an email and log of lots of failed sudo commands.
1972 # We could turn those off, but seems better not to.
1973 if [[ $EUID != 0 ]] && [[ $DID_SUDO ]]; then
1974 ps_char="SUDO $ps_char"
1975 fi
1976 if [[ ! $HISTFILE ]]; then
1977 ps_char="NOHIST $ps_char"
1978 fi
1979 PS1="${PS1%"${PS1#*[wW]}"} \[$ps_color\]$ps_char\[$term_nocolor\] "
1980
1981 # set titlebar. instead, using more advanced
1982 # titelbar below
1983 #echo -ne "$_title_escape $HOSTNAME ${PWD/#$HOME/~} \007"
1984 }
1985 PROMPT_COMMAND=prompt-command
1986
1987 if [[ $TERM == screen* ]]; then
1988 _title_escape="\033]..2;"
1989 else
1990 # somme sites recommend this, i dunno what the diff is.
1991 #_title_escape="\033]30;"
1992 _title_escape="\033]0;"
1993 fi
1994
1995 settitle () {
1996 # this makes it so we show the current command if
1997 # one is running, otherwise, show nothing
1998
1999 if [[ $1 == prompt-command ]]; then
2000 return 0
2001 fi
2002 if (( ${#BASH_ARGC[@]} == 1 && BASH_SUBSHELL == 0 )); then
2003 echo -ne "$_title_escape ${PWD/#$HOME/~} "
2004 printf "%s" "$*"
2005 echo -ne "\007"
2006 fi
2007 }
2008
2009 # note, this wont work:
2010 # x=$(mktemp); cp a $x
2011 # I havnt figured out why, bigger fish to fry.
2012 #
2013 # for titlebar.
2014 # condition from the screen man page i think.
2015 # note: duplicated in tx()
2016 if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
2017 trap 'settitle "$BASH_COMMAND"' DEBUG
2018 else
2019 trap DEBUG
2020 fi
2021
2022 fi
2023
2024 # * stuff that makes sense to be at the end
2025
2026
2027 # best practice
2028 unset IFS
2029
2030 # shellcheck disable=SC1090
2031 [[ -s "$HOME/.rvm/scripts/rvm" ]] && source "$HOME/.rvm/scripts/rvm" # Load RVM into a shell session *as a function*
2032
2033 # I had this idea to start a bash shell which would run an initial
2034 # command passed through this env variable, then continue on
2035 # interactively. But the use case I had in mind went away.
2036 #
2037 # if [[ $MY_INIT_CMD ]]; then
2038 # "${MY_INIT_CMD[@]}"
2039 # unset MY_INIT_CMD
2040 # fi
2041
2042 # ensure no bad programs appending to this file will have an affect
2043 return 0